clc;
%Matrix A und Ergebnisvektor b laden
load('spd_matrix.mat');

%Groesse von A berechnen und Speicher reservieren
n = length( A );
L = zeros( n, n );

%Cholesky-Zerlegung
for i=1:n
   L(i, i) = sqrt(A(i, i) - L(i, :)*L(i, :)');
   for j=(i + 1):n
      L(j, i) = (A(j, i) - L(i,:)*L(j ,:)')/L(i, i);
   end
end

%System loesen
y = L \ b;
x = L' \ y;

disp('Loesungsvektor x:');
disp(x);

disp('Matlab-Loesung:');
L2 = chol( A )';
y2 = L2 \ b;
x2 = L2' \ y2;
disp(x2);

%Komponentenweise Kontrolle der Loesung
stimmt = 0;
for i=1:length(x)
    if abs(x(i) - x2(i)) > 0.0001 
        stimmt = 1;
    end
end

if stimmt == 0
    disp('Die Ergebnisse stimmen ueberein!');
end
